r"""
    This code was generated by
  ___ ___   _   ___ _  _    _____ _   _    _  ___   ___      _   ___ ___      ___   _   ___     ___ ___ _  _ ___ ___    _ _____ ___  ___ 
 | _ \ __| /_\ / __| || |__|_   _/_\ | |  | |/ | \ / / |    /_\ | _ ) __|___ / _ \ /_\ |_ _|__ / __| __| \| | __| _ \  /_\_   _/ _ \| _ \
 |   / _| / _ \ (__| __ |___|| |/ _ \| |__| ' < \ V /| |__ / _ \| _ \__ \___| (_) / _ \ | |___| (_ | _|| .` | _||   / / _ \| || (_) |   /
 |_|_\___/_/ \_\___|_||_|    |_/_/ \_\____|_|\_\ |_| |____/_/ \_\___/___/    \___/_/ \_\___|   \___|___|_|\_|___|_|_\/_/ \_\_| \___/|_|_\
 
    Reach Authentix API
     Reach Authentix API helps you easily integrate user authentification in your application. The authentification allows to verify that a user is indeed at the origin of a request from your application.  At the moment, the Reach Authentix API supports the following channels:    * SMS      * Email   We are continuously working to add additionnal channels. ## Base URL All endpoints described in this documentation are relative to the following base URL: ``` https://api.reach.talkylabs.com/rest/authentix/v1/ ```  The API is provided over HTTPS protocol to ensure data privacy.  ## API Authentication Requests made to the API must be authenticated. You need to provide the `ApiUser` and `ApiKey` associated with your applet. This information could be found in the settings of the applet. ```curl curl -X GET [BASE_URL]/configurations -H \"ApiUser:[Your_Api_User]\" -H \"ApiKey:[Your_Api_Key]\" ``` ## Reach Authentix API Workflow Three steps are needed in order to authenticate a given user using the Reach Authentix API. ### Step 1: Create an Authentix configuration A configuration is a set of settings used to define and send an authentication code to a user. This includes, for example: ```   - the length of the authentication code,    - the message template,    - and so on... ``` A configuaration could be created via the web application or directly using the Reach Authentix API. This step does not need to be performed every time one wants to use the Reach Authentix API. Indeed, once created, a configuartion could be used to authenticate several users in the future.    ### Step 2: Send an authentication code A configuration is used to send an authentication code via a selected channel to a user. For now, the supported channels are `sms`, and `email`. We are working hard to support additional channels. Newly created authentications will have a status of `awaiting`. ### Step 3: Verify the authentication code This step allows to verify that the code submitted by the user matched the one sent previously. If, there is a match, then the status of the authentication changes from `awaiting` to `passed`. Otherwise, the status remains `awaiting` until either it is verified or it expires. In the latter case, the status becomes `expired`. 

    NOTE: This class is auto generated by OpenAPI Generator.
    https://openapi-generator.tech
    Do not edit the class manually.
"""

from typing import Optional
from talkylabs.reach.base.version import Version
from talkylabs.reach.base.domain import Domain
from talkylabs.reach.rest.api.authentix.authentication_trial_item import AuthenticationTrialItemList
from talkylabs.reach.rest.api.authentix.authentication_trial_stat_item import AuthenticationTrialStatItemList
from talkylabs.reach.rest.api.authentix.configuration_item import ConfigurationItemList


class Authentix(Version):

    def __init__(self, domain: Domain):
        """
        Initialize the Authentix version of Api

        :param domain: The Reach.api domain
        """
        super().__init__(domain, "rest")
        self._authentication_trial_items: Optional[AuthenticationTrialItemList] = None
        self._authentication_trial_stat_items: Optional[AuthenticationTrialStatItemList] = None
        self._configuration_items: Optional[ConfigurationItemList] = None
        
    @property
    def authentication_trial_items(self) -> AuthenticationTrialItemList:
        if self._authentication_trial_items is None:
            self._authentication_trial_items = AuthenticationTrialItemList(self)
        return self._authentication_trial_items

    @property
    def authentication_trial_stat_items(self) -> AuthenticationTrialStatItemList:
        if self._authentication_trial_stat_items is None:
            self._authentication_trial_stat_items = AuthenticationTrialStatItemList(self)
        return self._authentication_trial_stat_items

    @property
    def configuration_items(self) -> ConfigurationItemList:
        if self._configuration_items is None:
            self._configuration_items = ConfigurationItemList(self)
        return self._configuration_items

    def __repr__(self) -> str:
        """
        Provide a friendly representation
        :returns: Machine friendly representation
        """
        return "<Reach.Api.Authentix>"
